function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

mapNormals = {}
function generateNormals(layer, norms)
   
   for i = 1, tablelength(layer.data) do
      for p = 1, tablelength(layer.data[0]) do
        table.insert(mapNormals, lightWorld:newRectangle( (i-1)*25, (p-1)*25, 25, 25):setNormalMap(norms, (i-1)*25, (p-1)*25))
      end
   end
end



pLayers = {}

function handleParallax()
   for nam, obj in pairs(pLayers) do        
      obj.x = obj.truX + ((cam.x - (curMap.width*tileSize/2))/obj.properties.parallax)
      obj.y = obj.truY + ((cam.y - (curMap.height*tileSize/2))/obj.properties.parallax)
   end   
end



function changeMap(newMap, spawnPosition)
   curMap = mapList[newMap]
   
   pLayers = {}
   for nam, obj in pairs(curMap.layers) do
      if obj.properties.parallax then
         obj.truX = obj.x
         obj.truY = obj.y
         pLayers[obj.name] = obj
      end
   end   
   
    for nam, obj in pairs(curMap.layers.spawnPositions.objects) do
      if obj.name == spawnPosition then
            p1=nil
            deleteSprite("p1")
            p1= player:new()
            p1.name = "p1"
            addSprite(p1.name, p1)
            p1.x = obj.x-p1.oX
            p1.y = obj.y-p1.oY
            break
      end
   end   
   
   
   for k1, v1 in pairs(curMap.layers.CD.data) do
      
      for k2, v2 in pairs(v1) do
         if type(v2) == 'table' then
            if v2.gid == 2 then
              -- lightWorld:newRectangle(k2*25, k1*25, 25, 25):setShadow(true)
            end
         end
      end
   end

   for nam, obj in pairs(curMap.layers.camBound.objects) do
       cam = gamera.new(math.rd(obj.x), math.rd(obj.y), math.rd(obj.width), math.rd(obj.height))
       break
   end   
   cam.x = p1.x
   cam.y = p1.y
  
   

   print(newMap, spawnPosition)

end


function getCTile(tx,ty) 
   tx = math.floor(tx/tileSize) + 1
   ty = math.floor(ty/tileSize) + 1
   local tile = 0
   if curMap.layers.CD.data[ty] ~= nil then 
      if curMap.layers.CD.data[ty][tx] then 
            tile = curMap.layers.CD.data[ty][tx].gid
      end
   end  
   return tile
end
function cWithLevel(tx,ty)
   local tile = getCTile(tx,ty)
   local col = false
   tx = tx%tileSize
   ty = ty%tileSize

   if tile == 2 then col = true
      
   --Regular slopes
   --
   elseif tile == 3  then col = tx<ty 
   elseif tile == 4  then col = tx>-(ty-tileSize) 
   elseif tile == 5  then col = tx>ty 
   elseif tile == 6  then col = tx<-(ty-tileSize) 
   --Half Slopes
   --
   elseif tile == 9  then col = (tx/2)<ty
   elseif tile == 10 then col = (tx/2)+(tileSize/2)<ty
   elseif tile == 11 then col = (tx/2)>-(ty-tileSize)
   elseif tile == 12 then col = (tx/2)+(tileSize/2)>-(ty-tileSize)
   --Quarter Slopes
   --
   elseif tile == 17 then col = (tx/4)<ty
   elseif tile == 18 then col = (tx/4)+(tileSize/4)<ty
   elseif tile == 19 then col = (tx/4)+((tileSize*2)/4)<ty
   elseif tile == 20 then col = (tx/4)+((tileSize*3)/4)<ty

   elseif tile == 21 then col = (tx/4)>-(ty-tileSize)
   elseif tile == 22 then col = (tx/4)+((tileSize)/4)>-(ty-tileSize)
   elseif tile == 23 then col = (tx/4)+((tileSize*2)/4)>-(ty-tileSize)
   elseif tile == 24 then col = (tx/4)+((tileSize*3)/4)>-(ty-tileSize)
   
   elseif tile == 25 then col = true
   elseif tile == 26 then col = true
   elseif tile == 27 then col = true
   elseif tile == 28 then col = true

   elseif tile == 29 then col = true
elseif tile == 30 then col = true
   
     elseif tile == 31 then col = true
   elseif tile == 32 then col = true
   end


    
   return col
end


function cWithLevelNoSlope(tx,ty)
   local tile = getCTile(tx,ty)
   local col = false
   tx = tx%tileSize
   ty = ty%tileSize

   if tile == 2 then col = true
      elseif tile == 5  then col = tx>ty 
   elseif tile == 6  then col = tx<-(ty-tileSize) 
   end


    
   return col
end

function getCSlope(tx,ty)
   local tile = getCTile(tx,ty)
   local col = math.atan2(0,0)


   if tile == 2 then col = math.atan2(0,0)
      
   --Regular slopes
   --
   elseif tile == 3  then col = 0
   elseif tile == 4  then col =0
   elseif tile == 5  then col =0
   elseif tile == 6  then col = 0
   --Half Slopes
   --
   elseif tile == 9  then col = 0
   elseif tile == 10 then col = 0
   elseif tile == 11 then col = 0
   elseif tile == 12 then col =0
   --Quarter Slopes
   --
   elseif tile == 17 then col = 0
   elseif tile == 18 then col = 0
   elseif tile == 19 then col = 0
   elseif tile == 20 then col =0

   elseif tile == 21 then col = 0
   elseif tile == 22 then col = 0
   elseif tile == 23 then col = 0
   elseif tile == 24 then col = 0
   
   elseif tile == 25 then col = math.atan2(-2,1)
   elseif tile == 26 then col = math.atan2(-2,1)
   
   elseif tile == 27 then col = 0
   elseif tile == 28 then col = 0

   elseif tile == 29 then col = 0
elseif tile == 30 then col = 0
      elseif tile == 31 then col = 0
   elseif tile == 32 then col = 0
   end

   return col
end

function getSkiSlope(tx,ty)
   local tile = getCTile(tx,ty)
   local col = math.atan2(0,0)


   if tile == 2 then col = math.atan2(0,0)
      
   --Regular slopes
   --
   elseif tile == 3  then col = math.atan2(3,3) 
   elseif tile == 4  then col = math.atan2(-3,3) 
   elseif tile == 5  then col = -math.atan2(3,3)
   elseif tile == 6  then col = -math.atan2(-3,3)
   --Half Slopes
   --
   elseif tile == 9  then col = math.atan2(1.5,3)
   elseif tile == 10 then col = math.atan2(1.5,3)
   elseif tile == 11 then col = math.atan2(-1.5,3)
   elseif tile == 12 then col = math.atan2(-1.5,3)
   --Quarter Slopes
   --
   elseif tile == 17 then col = math.atan2(.75,3)
   elseif tile == 18 then col = math.atan2(.75,3)
   elseif tile == 19 then col = math.atan2(.75,3)
   elseif tile == 20 then col = math.atan2(.75,3)

   elseif tile == 21 then col = math.atan2(-.75,3)
   elseif tile == 22 then col = math.atan2(-.75,3)
   elseif tile == 23 then col = math.atan2(-.75,3)
   elseif tile == 24 then col = math.atan2(-.75,3)
   
   elseif tile == 25 then col = math.atan2(3,3)
   elseif tile == 26 then col = math.atan2(-3,3)
   
   
   elseif tile == 27 then col = math.atan2(1.5,3)
   elseif tile == 28 then col = math.atan2(.75,3)

   elseif tile == 29 then col = math.atan2(-.75,3)
   elseif tile == 30 then col = math.atan2(-1.5,3)
   
   elseif tile == 31  then col = -math.atan2(3,3)
   elseif tile == 32  then col = -math.atan2(-3,3)
   end

   return col
end

function transByRad( x, y, cx, cy, ox, oy, rad )
    local nx = (x - cx)*math.cos( rad ) - (y - cy)*math.sin( rad ) + ox
    local ny = (x - cx)*math.sin( rad ) + (y - cy)*math.cos( rad ) + oy

    return nx, ny;
end


function angleDiff(angle1,angle2)
   return (angle1-angle2+math.pi)%(2*math.pi) - math.pi
end